package cn.l7h.boing;

import java.awt.event.*;

/**
 * Measure where to and how fast the user drags the mouse.
 * Transmit these data to a Dot object.
 * @author jl
 */
final class SpeedSensor implements MouseMotionListener {
	private int xOld = 0;
	private int yOld = 0;
	private long tOld = 0;
	private Dot theDot = null;
	
	SpeedSensor(Dot d) {
		theDot = d;
	}
	
	public void mouseDragged(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();
		long t = System.currentTimeMillis();
		
		if(t - tOld < 500) { // near enough in time
			if(t == tOld) // can't compute velocity
				return;
			
			// compute velocity
			double dt = 0.001*(t-tOld);
			double dx = (x-xOld)/dt;
			double dy = (y-yOld)/dt;	
			theDot.set(x, y, dx, dy);
		}
				
		xOld = x;
		yOld = y;
		tOld = t;
	}
	
	public void mouseMoved(MouseEvent e)
	{}
}